<?xml version="1.0" encoding="UTF-8"?>
<?bluebottle format version="0.1" ?>
<?xml-stylesheet type="text/xsl" href="http://bluebottle.ethz.ch/bluebottle.xsl" ?>
<Text>
<Span style="Comment"><![CDATA[(** Bluebottle GUI Programming pattern collection.

	Theme: 	Resizer, a Panel extension.

	Purpose: Construct a window with four resizable quadrants of different colour.
				Each quadrant is a panel but these could be replaced by editors for instance.
*)]]></Span><Span style="Normal"><![CDATA[

MODULE GUIPat16;	]]></Span><Span style="Comment"><![CDATA[(** AUTHOR "afi"; November 24, 2005 *)
]]></Span><Span style="Normal"><![CDATA[
IMPORT
	AosModules, WMComponents, WM := WMWindowManager, WMStandardComponents,
	Utilities, WMGraphics
	;

TYPE
	]]></Span><Span style="Bold"><![CDATA[Window* = OBJECT (WMComponents.FormWindow)]]></Span><Span style="Normal"><![CDATA[

		]]></Span><Span style="Bold"><![CDATA[PROCEDURE CreateForm () : WMComponents.VisualComponent;]]></Span><Span style="Normal"><![CDATA[
		VAR
			panel, panelL, panelBL, panelR, panelBR : WMStandardComponents.Panel;
]]></Span><Span style="Stupid"><![CDATA[	]]></Span><Span style="Normal"><![CDATA[		resizerH, resizerV: WMStandardComponents.Resizer;

		BEGIN
			NEW (panel); panel.bounds.SetExtents (600, 400);
			
			NEW(panelL); 
			panelL.bounds.SetWidth(250); 
			panelL.alignment.Set(WMComponents.AlignLeft); panelL.fillColor.Set (WMGraphics.Red);
			panel.AddContent (panelL);
			
			NEW(resizerH);
			resizerH.alignment.Set(WMComponents.AlignRight);
			resizerH.bounds.SetWidth(6);
			panelL.AddContent(resizerH);

			NEW(panelBL);
			panelBL.bounds.SetHeight(250);
			panelBL.alignment.Set(WMComponents.AlignBottom); panelBL.fillColor.Set (WMGraphics.Green);

			NEW(resizerV);
			resizerV.alignment.Set(WMComponents.AlignTop);
			resizerV.bounds.SetHeight(6);
			panelBL.AddContent(resizerV);

			panelL.AddContent (panelBL);

			NEW(panelR); panelR.alignment.Set(WMComponents.AlignClient); panelR.fillColor.Set (0FFFF00FFH);
			panel.AddContent(panelR);

			NEW(panelBR);
			panelBR.alignment.Set (WMComponents.AlignBottom); panelBR.fillColor.Set (WMGraphics.Blue);
			panelBR.bounds.SetHeight (200);
			panelR.AddContent (panelBR);

			NEW (resizerV);
			resizerV.alignment.Set (WMComponents.AlignTop);
			resizerV.bounds.SetHeight(6);
			panelBR.AddContent (resizerV);

			RETURN panel
		END CreateForm;

		]]></Span><Span style="Bold"><![CDATA[PROCEDURE &New ();
]]></Span><Span style="Normal"><![CDATA[		VAR vc : WMComponents.VisualComponent;]]></Span><Span style="Comment"><![CDATA[
]]></Span><Span style="Normal"><![CDATA[		BEGIN
			vc := CreateForm ();
			Init (vc.bounds.GetWidth (), vc.bounds.GetHeight (), FALSE);
			SetContent (vc);
			WM.DefaultAddWindow (SELF);			
			SetTitle (Utilities.NewString ("GUIPat16"));		
		END New;

		]]></Span><Span style="Bold"><![CDATA[PROCEDURE Close ();]]></Span><Span style="Normal"><![CDATA[
		BEGIN

			Close^;
			winstance := NIL
		END Close;
		
	END Window;

VAR
	winstance : Window;

]]></Span><Span style="Comment"><![CDATA[(** Standard single window, non-restorable. *)]]></Span><Span style="Normal"><![CDATA[
]]></Span><Span style="Bold"><![CDATA[PROCEDURE Open* (par : ANY) : ANY;]]></Span><Span style="Normal"><![CDATA[
BEGIN
	IF winstance = NIL THEN NEW (winstance) END;
	RETURN NIL
END Open;
]]></Span><Span style="Bold"><![CDATA[
PROCEDURE Cleanup;
]]></Span><Span style="Normal"><![CDATA[BEGIN]]></Span><Span style="Bold"><![CDATA[
]]></Span><Span style="Normal"><![CDATA[	IF winstance # NIL THEN winstance.Close END
END Cleanup;

BEGIN
	AosModules.InstallTermHandler (Cleanup);

	]]></Span><Span style="Comment"><![CDATA[(* Additional BEGIN processing. *)]]></Span><Span style="Normal"><![CDATA[
END GUIPat16.

GUIPat16.Open ~
S.Free GUIPat16 ~

]]></Span><Span style="Bold"><![CDATA[Comments]]></Span><Span style="Normal"><![CDATA[

A.	.

B.	
]]></Span>

</Text>
